<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - report.info - QtWidgets/qsizepolicy.h</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">QtWidgets</a> - qsizepolicy.h<span style="font-size: 80%;"> (source / <a href="qsizepolicy.h.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">report.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">8</td>
            <td class="headerCovTableEntry">10</td>
            <td class="headerCovTableEntryMed">80.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2021-03-29 02:25:54</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">5</td>
            <td class="headerCovTableEntry">6</td>
            <td class="headerCovTableEntryMed">83.3 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : /****************************************************************************</a>
<a name="2"><span class="lineNum">       2 </span>            : **</a>
<a name="3"><span class="lineNum">       3 </span>            : ** Copyright (C) 2016 The Qt Company Ltd.</a>
<a name="4"><span class="lineNum">       4 </span>            : ** Contact: https://www.qt.io/licensing/</a>
<a name="5"><span class="lineNum">       5 </span>            : **</a>
<a name="6"><span class="lineNum">       6 </span>            : ** This file is part of the QtWidgets module of the Qt Toolkit.</a>
<a name="7"><span class="lineNum">       7 </span>            : **</a>
<a name="8"><span class="lineNum">       8 </span>            : ** $QT_BEGIN_LICENSE:LGPL$</a>
<a name="9"><span class="lineNum">       9 </span>            : ** Commercial License Usage</a>
<a name="10"><span class="lineNum">      10 </span>            : ** Licensees holding valid commercial Qt licenses may use this file in</a>
<a name="11"><span class="lineNum">      11 </span>            : ** accordance with the commercial license agreement provided with the</a>
<a name="12"><span class="lineNum">      12 </span>            : ** Software or, alternatively, in accordance with the terms contained in</a>
<a name="13"><span class="lineNum">      13 </span>            : ** a written agreement between you and The Qt Company. For licensing terms</a>
<a name="14"><span class="lineNum">      14 </span>            : ** and conditions see https://www.qt.io/terms-conditions. For further</a>
<a name="15"><span class="lineNum">      15 </span>            : ** information use the contact form at https://www.qt.io/contact-us.</a>
<a name="16"><span class="lineNum">      16 </span>            : **</a>
<a name="17"><span class="lineNum">      17 </span>            : ** GNU Lesser General Public License Usage</a>
<a name="18"><span class="lineNum">      18 </span>            : ** Alternatively, this file may be used under the terms of the GNU Lesser</a>
<a name="19"><span class="lineNum">      19 </span>            : ** General Public License version 3 as published by the Free Software</a>
<a name="20"><span class="lineNum">      20 </span>            : ** Foundation and appearing in the file LICENSE.LGPL3 included in the</a>
<a name="21"><span class="lineNum">      21 </span>            : ** packaging of this file. Please review the following information to</a>
<a name="22"><span class="lineNum">      22 </span>            : ** ensure the GNU Lesser General Public License version 3 requirements</a>
<a name="23"><span class="lineNum">      23 </span>            : ** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.</a>
<a name="24"><span class="lineNum">      24 </span>            : **</a>
<a name="25"><span class="lineNum">      25 </span>            : ** GNU General Public License Usage</a>
<a name="26"><span class="lineNum">      26 </span>            : ** Alternatively, this file may be used under the terms of the GNU</a>
<a name="27"><span class="lineNum">      27 </span>            : ** General Public License version 2.0 or (at your option) the GNU General</a>
<a name="28"><span class="lineNum">      28 </span>            : ** Public license version 3 or any later version approved by the KDE Free</a>
<a name="29"><span class="lineNum">      29 </span>            : ** Qt Foundation. The licenses are as published by the Free Software</a>
<a name="30"><span class="lineNum">      30 </span>            : ** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3</a>
<a name="31"><span class="lineNum">      31 </span>            : ** included in the packaging of this file. Please review the following</a>
<a name="32"><span class="lineNum">      32 </span>            : ** information to ensure the GNU General Public License requirements will</a>
<a name="33"><span class="lineNum">      33 </span>            : ** be met: https://www.gnu.org/licenses/gpl-2.0.html and</a>
<a name="34"><span class="lineNum">      34 </span>            : ** https://www.gnu.org/licenses/gpl-3.0.html.</a>
<a name="35"><span class="lineNum">      35 </span>            : **</a>
<a name="36"><span class="lineNum">      36 </span>            : ** $QT_END_LICENSE$</a>
<a name="37"><span class="lineNum">      37 </span>            : **</a>
<a name="38"><span class="lineNum">      38 </span>            : ****************************************************************************/</a>
<a name="39"><span class="lineNum">      39 </span>            : </a>
<a name="40"><span class="lineNum">      40 </span>            : #ifndef QSIZEPOLICY_H</a>
<a name="41"><span class="lineNum">      41 </span>            : #define QSIZEPOLICY_H</a>
<a name="42"><span class="lineNum">      42 </span>            : </a>
<a name="43"><span class="lineNum">      43 </span>            : #include &lt;QtWidgets/qtwidgetsglobal.h&gt;</a>
<a name="44"><span class="lineNum">      44 </span>            : #include &lt;QtCore/qobject.h&gt;</a>
<a name="45"><span class="lineNum">      45 </span>            : #include &lt;QtCore/qalgorithms.h&gt;</a>
<a name="46"><span class="lineNum">      46 </span>            : </a>
<a name="47"><span class="lineNum">      47 </span>            : QT_BEGIN_NAMESPACE</a>
<a name="48"><span class="lineNum">      48 </span>            : </a>
<a name="49"><span class="lineNum">      49 </span>            : // gcc &lt; 4.8.0 has problems with init'ing variant members in constexpr ctors</a>
<a name="50"><span class="lineNum">      50 </span>            : // https://gcc.gnu.org/bugzilla/show_bug.cgi?id=54922</a>
<a name="51"><span class="lineNum">      51 </span>            : #if !defined(Q_CC_GNU) || defined(Q_CC_INTEL) || defined(Q_CC_CLANG) || Q_CC_GNU &gt;= 408</a>
<a name="52"><span class="lineNum">      52 </span>            : # define QT_SIZEPOLICY_CONSTEXPR Q_DECL_CONSTEXPR</a>
<a name="53"><span class="lineNum">      53 </span>            : # if defined(Q_COMPILER_UNIFORM_INIT)</a>
<a name="54"><span class="lineNum">      54 </span>            : #  define QT_SIZEPOLICY_CONSTEXPR_AND_UNIFORM_INIT Q_DECL_CONSTEXPR</a>
<a name="55"><span class="lineNum">      55 </span>            : # endif // uniform-init</a>
<a name="56"><span class="lineNum">      56 </span>            : #endif</a>
<a name="57"><span class="lineNum">      57 </span>            : </a>
<a name="58"><span class="lineNum">      58 </span>            : #ifndef QT_SIZEPOLICY_CONSTEXPR</a>
<a name="59"><span class="lineNum">      59 </span>            : # define QT_SIZEPOLICY_CONSTEXPR</a>
<a name="60"><span class="lineNum">      60 </span>            : #endif</a>
<a name="61"><span class="lineNum">      61 </span>            : #ifndef QT_SIZEPOLICY_CONSTEXPR_AND_UNIFORM_INIT</a>
<a name="62"><span class="lineNum">      62 </span>            : # define QT_SIZEPOLICY_CONSTEXPR_AND_UNIFORM_INIT</a>
<a name="63"><span class="lineNum">      63 </span>            : #endif</a>
<a name="64"><span class="lineNum">      64 </span>            : </a>
<a name="65"><span class="lineNum">      65 </span>            : class QVariant;</a>
<a name="66"><span class="lineNum">      66 </span>            : class QSizePolicy;</a>
<a name="67"><span class="lineNum">      67 </span>            : </a>
<a name="68"><span class="lineNum">      68 </span>            : Q_DECL_CONST_FUNCTION inline uint qHash(QSizePolicy key, uint seed = 0) noexcept;</a>
<a name="69"><span class="lineNum">      69 </span>            : </a>
<a name="70"><span class="lineNum">      70 </span>            : class Q_WIDGETS_EXPORT QSizePolicy</a>
<a name="71"><span class="lineNum">      71 </span>            : {</a>
<a name="72"><span class="lineNum">      72 </span>            :     Q_GADGET</a>
<a name="73"><span class="lineNum">      73 </span>            : </a>
<a name="74"><span class="lineNum">      74 </span>            : public:</a>
<a name="75"><span class="lineNum">      75 </span>            :     enum PolicyFlag {</a>
<a name="76"><span class="lineNum">      76 </span>            :         GrowFlag = 1,</a>
<a name="77"><span class="lineNum">      77 </span>            :         ExpandFlag = 2,</a>
<a name="78"><span class="lineNum">      78 </span>            :         ShrinkFlag = 4,</a>
<a name="79"><span class="lineNum">      79 </span>            :         IgnoreFlag = 8</a>
<a name="80"><span class="lineNum">      80 </span>            :     };</a>
<a name="81"><span class="lineNum">      81 </span>            : </a>
<a name="82"><span class="lineNum">      82 </span>            :     enum Policy {</a>
<a name="83"><span class="lineNum">      83 </span>            :         Fixed = 0,</a>
<a name="84"><span class="lineNum">      84 </span>            :         Minimum = GrowFlag,</a>
<a name="85"><span class="lineNum">      85 </span>            :         Maximum = ShrinkFlag,</a>
<a name="86"><span class="lineNum">      86 </span>            :         Preferred = GrowFlag | ShrinkFlag,</a>
<a name="87"><span class="lineNum">      87 </span>            :         MinimumExpanding = GrowFlag | ExpandFlag,</a>
<a name="88"><span class="lineNum">      88 </span>            :         Expanding = GrowFlag | ShrinkFlag | ExpandFlag,</a>
<a name="89"><span class="lineNum">      89 </span>            :         Ignored = ShrinkFlag | GrowFlag | IgnoreFlag</a>
<a name="90"><span class="lineNum">      90 </span>            :     };</a>
<a name="91"><span class="lineNum">      91 </span>            :     Q_ENUM(Policy)</a>
<a name="92"><span class="lineNum">      92 </span>            : </a>
<a name="93"><span class="lineNum">      93 </span>            :     enum ControlType {</a>
<a name="94"><span class="lineNum">      94 </span>            :         DefaultType      = 0x00000001,</a>
<a name="95"><span class="lineNum">      95 </span>            :         ButtonBox        = 0x00000002,</a>
<a name="96"><span class="lineNum">      96 </span>            :         CheckBox         = 0x00000004,</a>
<a name="97"><span class="lineNum">      97 </span>            :         ComboBox         = 0x00000008,</a>
<a name="98"><span class="lineNum">      98 </span>            :         Frame            = 0x00000010,</a>
<a name="99"><span class="lineNum">      99 </span>            :         GroupBox         = 0x00000020,</a>
<a name="100"><span class="lineNum">     100 </span>            :         Label            = 0x00000040,</a>
<a name="101"><span class="lineNum">     101 </span>            :         Line             = 0x00000080,</a>
<a name="102"><span class="lineNum">     102 </span>            :         LineEdit         = 0x00000100,</a>
<a name="103"><span class="lineNum">     103 </span>            :         PushButton       = 0x00000200,</a>
<a name="104"><span class="lineNum">     104 </span>            :         RadioButton      = 0x00000400,</a>
<a name="105"><span class="lineNum">     105 </span>            :         Slider           = 0x00000800,</a>
<a name="106"><span class="lineNum">     106 </span>            :         SpinBox          = 0x00001000,</a>
<a name="107"><span class="lineNum">     107 </span>            :         TabWidget        = 0x00002000,</a>
<a name="108"><span class="lineNum">     108 </span>            :         ToolButton       = 0x00004000</a>
<a name="109"><span class="lineNum">     109 </span>            :     };</a>
<a name="110"><span class="lineNum">     110 </span>            :     Q_DECLARE_FLAGS(ControlTypes, ControlType)</a>
<a name="111"><span class="lineNum">     111 </span>            :     Q_FLAG(ControlTypes)</a>
<a name="112"><span class="lineNum">     112 </span>            : </a>
<a name="113"><span class="lineNum">     113 </span>            :     QT_SIZEPOLICY_CONSTEXPR QSizePolicy() noexcept : data(0) { }</a>
<a name="114"><span class="lineNum">     114 </span>            : </a>
<a name="115"><span class="lineNum">     115 </span>            : #if defined(Q_COMPILER_UNIFORM_INIT) &amp;&amp; !defined(Q_QDOC)</a>
<a name="116"><span class="lineNum">     116 </span><span class="lineCov">          4 :     QT_SIZEPOLICY_CONSTEXPR QSizePolicy(Policy horizontal, Policy vertical, ControlType type = DefaultType) noexcept</span></a>
<a name="117"><span class="lineNum">     117 </span><span class="lineCov">          4 :         : bits{0, 0, quint32(horizontal), quint32(vertical),</span></a>
<a name="118"><span class="lineNum">     118 </span><span class="lineCov">          4 :                type == DefaultType ? 0 : toControlTypeFieldValue(type), 0, 0, 0}</span></a>
<a name="119"><span class="lineNum">     119 </span><span class="lineCov">          4 :     {}</span></a>
<a name="120"><span class="lineNum">     120 </span>            : #else</a>
<a name="121"><span class="lineNum">     121 </span>            :     QSizePolicy(Policy horizontal, Policy vertical, ControlType type = DefaultType) noexcept</a>
<a name="122"><span class="lineNum">     122 </span>            :         : data(0) {</a>
<a name="123"><span class="lineNum">     123 </span>            :         bits.horPolicy = horizontal;</a>
<a name="124"><span class="lineNum">     124 </span>            :         bits.verPolicy = vertical;</a>
<a name="125"><span class="lineNum">     125 </span>            :         setControlType(type);</a>
<a name="126"><span class="lineNum">     126 </span>            :     }</a>
<a name="127"><span class="lineNum">     127 </span>            : #endif // uniform-init</a>
<a name="128"><span class="lineNum">     128 </span>            :     QT_SIZEPOLICY_CONSTEXPR Policy horizontalPolicy() const noexcept { return static_cast&lt;Policy&gt;(bits.horPolicy); }</a>
<a name="129"><span class="lineNum">     129 </span>            :     QT_SIZEPOLICY_CONSTEXPR Policy verticalPolicy() const noexcept { return static_cast&lt;Policy&gt;(bits.verPolicy); }</a>
<a name="130"><span class="lineNum">     130 </span>            :     ControlType controlType() const noexcept;</a>
<a name="131"><span class="lineNum">     131 </span>            : </a>
<a name="132"><span class="lineNum">     132 </span>            :     Q_DECL_RELAXED_CONSTEXPR void setHorizontalPolicy(Policy d) noexcept { bits.horPolicy = d; }</a>
<a name="133"><span class="lineNum">     133 </span>            :     Q_DECL_RELAXED_CONSTEXPR void setVerticalPolicy(Policy d) noexcept { bits.verPolicy = d; }</a>
<a name="134"><span class="lineNum">     134 </span>            :     void setControlType(ControlType type) noexcept;</a>
<a name="135"><span class="lineNum">     135 </span>            : </a>
<a name="136"><span class="lineNum">     136 </span>            :     QT_SIZEPOLICY_CONSTEXPR Qt::Orientations expandingDirections() const noexcept {</a>
<a name="137"><span class="lineNum">     137 </span>            :         return ( (verticalPolicy()   &amp; ExpandFlag) ? Qt::Vertical   : Qt::Orientations() )</a>
<a name="138"><span class="lineNum">     138 </span>            :              | ( (horizontalPolicy() &amp; ExpandFlag) ? Qt::Horizontal : Qt::Orientations() ) ;</a>
<a name="139"><span class="lineNum">     139 </span>            :     }</a>
<a name="140"><span class="lineNum">     140 </span>            : </a>
<a name="141"><span class="lineNum">     141 </span><span class="lineCov">          3 :     Q_DECL_RELAXED_CONSTEXPR void setHeightForWidth(bool b) noexcept { bits.hfw = b;  }</span></a>
<a name="142"><span class="lineNum">     142 </span><span class="lineCov">          3 :     QT_SIZEPOLICY_CONSTEXPR bool hasHeightForWidth() const noexcept { return bits.hfw; }</span></a>
<a name="143"><span class="lineNum">     143 </span>            :     Q_DECL_RELAXED_CONSTEXPR void setWidthForHeight(bool b) noexcept { bits.wfh = b;  }</a>
<a name="144"><span class="lineNum">     144 </span>            :     QT_SIZEPOLICY_CONSTEXPR bool hasWidthForHeight() const noexcept { return bits.wfh; }</a>
<a name="145"><span class="lineNum">     145 </span>            : </a>
<a name="146"><span class="lineNum">     146 </span>            :     QT_SIZEPOLICY_CONSTEXPR bool operator==(const QSizePolicy&amp; s) const noexcept { return data == s.data; }</a>
<a name="147"><span class="lineNum">     147 </span>            :     QT_SIZEPOLICY_CONSTEXPR bool operator!=(const QSizePolicy&amp; s) const noexcept { return data != s.data; }</a>
<a name="148"><span class="lineNum">     148 </span>            : </a>
<a name="149"><span class="lineNum">     149 </span>            :     friend Q_DECL_CONST_FUNCTION uint qHash(QSizePolicy key, uint seed) noexcept { return qHash(key.data, seed); }</a>
<a name="150"><span class="lineNum">     150 </span>            : </a>
<a name="151"><span class="lineNum">     151 </span>            :     operator QVariant() const;</a>
<a name="152"><span class="lineNum">     152 </span>            : </a>
<a name="153"><span class="lineNum">     153 </span>            :     QT_SIZEPOLICY_CONSTEXPR int horizontalStretch() const noexcept { return static_cast&lt;int&gt;(bits.horStretch); }</a>
<a name="154"><span class="lineNum">     154 </span>            :     QT_SIZEPOLICY_CONSTEXPR int verticalStretch() const noexcept { return static_cast&lt;int&gt;(bits.verStretch); }</a>
<a name="155"><span class="lineNum">     155 </span><span class="lineCov">          2 :     Q_DECL_RELAXED_CONSTEXPR void setHorizontalStretch(int stretchFactor) { bits.horStretch = static_cast&lt;quint32&gt;(qBound(0, stretchFactor, 255)); }</span></a>
<a name="156"><span class="lineNum">     156 </span><span class="lineCov">          2 :     Q_DECL_RELAXED_CONSTEXPR void setVerticalStretch(int stretchFactor) { bits.verStretch = static_cast&lt;quint32&gt;(qBound(0, stretchFactor, 255)); }</span></a>
<a name="157"><span class="lineNum">     157 </span>            : </a>
<a name="158"><span class="lineNum">     158 </span>            :     QT_SIZEPOLICY_CONSTEXPR bool retainSizeWhenHidden() const noexcept { return bits.retainSizeWhenHidden; }</a>
<a name="159"><span class="lineNum">     159 </span>            :     Q_DECL_RELAXED_CONSTEXPR void setRetainSizeWhenHidden(bool retainSize) noexcept { bits.retainSizeWhenHidden = retainSize; }</a>
<a name="160"><span class="lineNum">     160 </span>            : </a>
<a name="161"><span class="lineNum">     161 </span>            :     Q_DECL_RELAXED_CONSTEXPR void transpose() noexcept { *this = transposed(); }</a>
<a name="162"><span class="lineNum">     162 </span>            :     Q_REQUIRED_RESULT</a>
<a name="163"><span class="lineNum">     163 </span>            : #ifndef Q_QDOC</a>
<a name="164"><span class="lineNum">     164 </span>            :     QT_SIZEPOLICY_CONSTEXPR_AND_UNIFORM_INIT</a>
<a name="165"><span class="lineNum">     165 </span>            : #endif</a>
<a name="166"><span class="lineNum">     166 </span>            :     QSizePolicy transposed() const noexcept</a>
<a name="167"><span class="lineNum">     167 </span>            :     {</a>
<a name="168"><span class="lineNum">     168 </span>            :         return QSizePolicy(bits.transposed());</a>
<a name="169"><span class="lineNum">     169 </span>            :     }</a>
<a name="170"><span class="lineNum">     170 </span>            : </a>
<a name="171"><span class="lineNum">     171 </span>            : private:</a>
<a name="172"><span class="lineNum">     172 </span>            : #ifndef QT_NO_DATASTREAM</a>
<a name="173"><span class="lineNum">     173 </span>            :     friend Q_WIDGETS_EXPORT QDataStream &amp;operator&lt;&lt;(QDataStream &amp;, const QSizePolicy &amp;);</a>
<a name="174"><span class="lineNum">     174 </span>            :     friend Q_WIDGETS_EXPORT QDataStream &amp;operator&gt;&gt;(QDataStream &amp;, QSizePolicy &amp;);</a>
<a name="175"><span class="lineNum">     175 </span>            : #endif</a>
<a name="176"><span class="lineNum">     176 </span>            :     QT_SIZEPOLICY_CONSTEXPR QSizePolicy(int i) noexcept : data(i) { }</a>
<a name="177"><span class="lineNum">     177 </span>            :     struct Bits;</a>
<a name="178"><span class="lineNum">     178 </span>            :     QT_SIZEPOLICY_CONSTEXPR explicit QSizePolicy(Bits b) noexcept : bits(b) { }</a>
<a name="179"><span class="lineNum">     179 </span>            : </a>
<a name="180"><span class="lineNum">     180 </span><span class="lineNoCov">          0 :     static Q_DECL_RELAXED_CONSTEXPR quint32 toControlTypeFieldValue(ControlType type) noexcept</span></a>
<a name="181"><span class="lineNum">     181 </span>            :     {</a>
<a name="182"><span class="lineNum">     182 </span>            :         /*</a>
<a name="183"><span class="lineNum">     183 </span>            :           The control type is a flag type, with values 0x1, 0x2, 0x4, 0x8, 0x10,</a>
<a name="184"><span class="lineNum">     184 </span>            :           etc. In memory, we pack it onto the available bits (CTSize) in</a>
<a name="185"><span class="lineNum">     185 </span>            :           setControlType(), and unpack it here.</a>
<a name="186"><span class="lineNum">     186 </span>            : </a>
<a name="187"><span class="lineNum">     187 </span>            :           Example:</a>
<a name="188"><span class="lineNum">     188 </span>            : </a>
<a name="189"><span class="lineNum">     189 </span>            :           0x00000001 maps to 0</a>
<a name="190"><span class="lineNum">     190 </span>            :           0x00000002 maps to 1</a>
<a name="191"><span class="lineNum">     191 </span>            :           0x00000004 maps to 2</a>
<a name="192"><span class="lineNum">     192 </span>            :           0x00000008 maps to 3</a>
<a name="193"><span class="lineNum">     193 </span>            :           etc.</a>
<a name="194"><span class="lineNum">     194 </span>            :         */</a>
<a name="195"><span class="lineNum">     195 </span>            : </a>
<a name="196"><span class="lineNum">     196 </span><span class="lineNoCov">          0 :         return qCountTrailingZeroBits(static_cast&lt;quint32&gt;(type));</span></a>
<a name="197"><span class="lineNum">     197 </span>            :     }</a>
<a name="198"><span class="lineNum">     198 </span>            : </a>
<a name="199"><span class="lineNum">     199 </span>            :     struct Bits {</a>
<a name="200"><span class="lineNum">     200 </span>            :         quint32 horStretch : 8;</a>
<a name="201"><span class="lineNum">     201 </span>            :         quint32 verStretch : 8;</a>
<a name="202"><span class="lineNum">     202 </span>            :         quint32 horPolicy : 4;</a>
<a name="203"><span class="lineNum">     203 </span>            :         quint32 verPolicy : 4;</a>
<a name="204"><span class="lineNum">     204 </span>            :         quint32 ctype : 5;</a>
<a name="205"><span class="lineNum">     205 </span>            :         quint32 hfw : 1;</a>
<a name="206"><span class="lineNum">     206 </span>            :         quint32 wfh : 1;</a>
<a name="207"><span class="lineNum">     207 </span>            :         quint32 retainSizeWhenHidden : 1;</a>
<a name="208"><span class="lineNum">     208 </span>            : </a>
<a name="209"><span class="lineNum">     209 </span>            :         QT_SIZEPOLICY_CONSTEXPR_AND_UNIFORM_INIT</a>
<a name="210"><span class="lineNum">     210 </span>            :         Bits transposed() const noexcept</a>
<a name="211"><span class="lineNum">     211 </span>            :         {</a>
<a name="212"><span class="lineNum">     212 </span>            :             return {verStretch, // \ swap</a>
<a name="213"><span class="lineNum">     213 </span>            :                     horStretch, // /</a>
<a name="214"><span class="lineNum">     214 </span>            :                     verPolicy, // \ swap</a>
<a name="215"><span class="lineNum">     215 </span>            :                     horPolicy, // /</a>
<a name="216"><span class="lineNum">     216 </span>            :                     ctype,</a>
<a name="217"><span class="lineNum">     217 </span>            :                     hfw, // \ don't swap (historic behavior)</a>
<a name="218"><span class="lineNum">     218 </span>            :                     wfh, // /</a>
<a name="219"><span class="lineNum">     219 </span>            :                     retainSizeWhenHidden};</a>
<a name="220"><span class="lineNum">     220 </span>            :         }</a>
<a name="221"><span class="lineNum">     221 </span>            :     };</a>
<a name="222"><span class="lineNum">     222 </span>            :     union {</a>
<a name="223"><span class="lineNum">     223 </span>            :         Bits bits;</a>
<a name="224"><span class="lineNum">     224 </span>            :         quint32 data;</a>
<a name="225"><span class="lineNum">     225 </span>            :     };</a>
<a name="226"><span class="lineNum">     226 </span>            : };</a>
<a name="227"><span class="lineNum">     227 </span>            : #if QT_VERSION &gt;= QT_VERSION_CHECK(6,0,0)</a>
<a name="228"><span class="lineNum">     228 </span>            : // Can't add in Qt 5, as QList&lt;QSizePolicy&gt; would be BiC:</a>
<a name="229"><span class="lineNum">     229 </span>            : Q_DECLARE_TYPEINFO(QSizePolicy, Q_PRIMITIVE_TYPE);</a>
<a name="230"><span class="lineNum">     230 </span>            : #else</a>
<a name="231"><span class="lineNum">     231 </span>            : Q_DECLARE_TYPEINFO(QSizePolicy, Q_RELOCATABLE_TYPE);</a>
<a name="232"><span class="lineNum">     232 </span>            : #endif</a>
<a name="233"><span class="lineNum">     233 </span>            : </a>
<a name="234"><span class="lineNum">     234 </span>            : Q_DECLARE_OPERATORS_FOR_FLAGS(QSizePolicy::ControlTypes)</a>
<a name="235"><span class="lineNum">     235 </span>            : </a>
<a name="236"><span class="lineNum">     236 </span>            : #ifndef QT_NO_DATASTREAM</a>
<a name="237"><span class="lineNum">     237 </span>            : Q_WIDGETS_EXPORT QDataStream &amp;operator&lt;&lt;(QDataStream &amp;, const QSizePolicy &amp;);</a>
<a name="238"><span class="lineNum">     238 </span>            : Q_WIDGETS_EXPORT QDataStream &amp;operator&gt;&gt;(QDataStream &amp;, QSizePolicy &amp;);</a>
<a name="239"><span class="lineNum">     239 </span>            : #endif</a>
<a name="240"><span class="lineNum">     240 </span>            : </a>
<a name="241"><span class="lineNum">     241 </span>            : #ifndef QT_NO_DEBUG_STREAM</a>
<a name="242"><span class="lineNum">     242 </span>            : Q_WIDGETS_EXPORT QDebug operator&lt;&lt;(QDebug dbg, const QSizePolicy &amp;);</a>
<a name="243"><span class="lineNum">     243 </span>            : #endif</a>
<a name="244"><span class="lineNum">     244 </span>            : </a>
<a name="245"><span class="lineNum">     245 </span>            : </a>
<a name="246"><span class="lineNum">     246 </span>            : #undef QT_SIZEPOLICY_CONSTEXPR</a>
<a name="247"><span class="lineNum">     247 </span>            : #undef QT_SIZEPOLICY_CONSTEXPR_AND_UNIFORM_INIT</a>
<a name="248"><span class="lineNum">     248 </span>            : </a>
<a name="249"><span class="lineNum">     249 </span>            : QT_END_NAMESPACE</a>
<a name="250"><span class="lineNum">     250 </span>            : </a>
<a name="251"><span class="lineNum">     251 </span>            : #endif // QSIZEPOLICY_H</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
